.row
    //.col.pr-1
        .card.mb-4
            .card-header#stc Sample Test Cases
            .card-body.collapse#stcChild.test-case-height
                table.table
                    thead
                        th(scope='col') Input Case
                        th(scope='col') Expected Output
                        th(scope='col') CPU (s)
                        th(scope='col') Memory (MB)
                    tbody
                        each cases in data.code.samples
                            tr
                                td.newlinesupport= cases.input
                                td.newlinesupport= cases.output
                                td= cases.cpulimit
                                td= cases.memlimit
    //.col.pl-1
        .card.mb-4
            .card-header#atc Actual Test Cases
            .card-body.collapse#atcChild.test-case-height
                table.table
                    thead
                        th(scope='col') Input Case
                        th(scope='col') Expected Output
                        th(scope='col') CPU (s)
                        th(scope='col') Memory (MB)
                        th(scope='col') Score
                    tbody
                        each cases in data.code.actual
                            tr
                                td.newlinesupport= cases.input
                                td.newlinesupport= cases.output
                                td= cases.cpulimit
                                td= cases.memlimit
                                td= cases.score
    script.
        $("#atc").click(() => $("#atcChild").collapse('toggle'));
        $("#stc").click(() => $("#stcChild").collapse('toggle'));

include ../../meta/prismjs
.row
    .col
        h2 Supported Languages
        span View template by selecting language
        table#courseTable.table.w-100

        include ../../meta/datatables

        script.
            const entityMap = {'&': '&amp;', '<': '&lt;', '>': '&gt;', '"': '&quot;', "'": '&#39;', '/': '&#x2F;', '`': '&#x60;', '=': '&#x3D;'};
            function escapeHtml (string) {return String(string).replace(/[&<>"'`=\/]/g, function (s) {return entityMap[s];});}
            function format(d) {
                return `<div class="sliding"><table cellpadding="5" cellspacing="0" border="0" style="padding-left:50px; width: 100%;"><thead><th scope="col">Template</th></thead><tbody><tr><td><pre><code class="incode lang-${d.type}">${escapeHtml(d.template)}</code></pre></td></tr></tbody></table></div>`;
            }
            $(document).ready(() => {
                let table;
                let buttons = [
                    {
                        text: 'Add Language',
                        action: () => {
                            window.location.href = `/questions/info/#{data.questionbankid}/qninfo/#{data.id}/addlang`
                        }
                    },
                    {
                        text: 'Try Question',
                        className: 'btn-warning',
                        action: () => {
                            window.location.href = `/questions/info/#{data.questionbankid}/qninfo/#{data.id}/trycode`
                        }
                    }
                    ];
                table = $('#courseTable').DataTable({
                    ajax: '/questions/info/#{data.questionbankid}/qninfo/#{data.id}/codetemplates',
                    dom: 'Brftilp',
                    buttons: buttons,
                    responsive: true,
                    select: 'single',
                    deferRender: true,
                    createdRow: function (row, _, _, _) {
                        $(row).addClass('dtcs');
                    },
                    columns: [
                        { title: "Type", data: 'type', visible: false},
                        { title: "Language", data: 'langname'},
                        { title: "prilang", data: 'isprimarybool', visible: false},
                        {
                            title: "Primary Language", data: null, render: (data) => {
                                return (data.isprimarybool) ? "<i class='fad fa-check-circle text-success fa-lg'></i>" : "<i class='fad fa-times-circle text-danger fa-lg'></i>";
                            }, visible: true
                        },
                        {title: "Filename", data: 'filename'},
                        { title: "Actions",
                            className: 'details-control',
                            orderable: false,
                            data: null,
                            width: "150px",
                            render: (data) => {
                                let btn = `<a href="/questions/info/#{data.questionbankid}/qninfo/#{data.id}/editlang/${data.type}" class="btn btn-outline-secondary" data-toggle="tooltip" title="Edit Language" data-placement="bottom"><i class="fa fa-edit"></i></a>`;
                                if (!data.isprimarybool) btn += `<a href="/questions/info/#{data.questionbankid}/qninfo/#{data.id}/mkpri/${data.type}" class="btn btn-outline-secondary ml-1" data-toggle="tooltip" title="Make Primary Language" data-placement="bottom"><i class="fa fa-key"></i></a>`;
                                return btn;
                            },
                        }
                    ]
                });

                $("body").tooltip({ selector: '[data-toggle=tooltip]', trigger: 'hover' });
                table.on('draw', () => MathJax.typesetPromise())
                table.on('select deselect', (e, dt, type, indexes) => {
                    let row = table.row(indexes);
                    if (row.child.isShown()) {
                        // This row is already open - close it
                        $('div.sliding', row.child()).slideUp(() => {
                            row.child.hide();
                            $(row.node()).removeClass('shown');
                        });
                    } else {
                        // Open this row
                        row.child(format(row.data()), 'nope-padding').show();
                        $(row.node()).addClass('shown');
                        $('div.sliding', row.child()).slideDown();
                        $('.incode').each((e) => {
                            Prism.highlightElement($('.incode')[e]);
                        });
                    }
                });
            });
